//+------------------------------------------------------------------+
//|                                                          tfs.mq5 |
//|                                    Copyright 2023, Andy Thompson |
//|                                         mailto:andydoc@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2023, Andy Thompson"
#property link      "mailto:andydoc@gmail.com"
#property version   "1.00"

#include <TimeFrames.mqh>
 
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
{
   CTimeFrames tfs;  // using all periods when calling the default constructor
   string res = "dictName = {}\n";
   string pyFile = "#Returns dict dictName of records: dictName['mt5.%timeframe%'] = {'mt5 value' : %int enumeration value%, 'minutes' : %minutes%, 'seconds' : %seconds%}\ndef getTimeframes(dictName):\n\t";
   for(tfs = PERIOD_M1; tfs <= PERIOD_MN1;tfs++)
   {
      //ENUM_TIMEFRAMES period = tfs.Period(); //example of calling for current period.
      res+= StringFormat("\tdictName['mt5.%s'] = {'mt5 value' : %u, 'int minutes' : %s, 'int seconds' : %s}",tfs.ToString(),tfs.Period(),(string)(tfs.ToSeconds()/60),(string)tfs.ToSeconds());
      if(tfs.Period() != PERIOD_MN1){
         res+= "\n";
      }
   }
   //Print(res);
   StringAdd(pyFile,res);
   StringAdd(pyFile,"\n\treturn dictName");
   Print(pyFile);
   int filehandle=FileOpen("getTimeframes.py",FILE_WRITE|FILE_TXT,0,CP_UTF8);
   FileWriteString(filehandle,pyFile);
   FileClose(filehandle);
   Print(TerminalInfoInteger(TERMINAL_CODEPAGE));
  }
//+------------------------------------------------------------------+
